#ifndef bit_h
#define bit_h

#define bit_opsnum 6

class bit {
  static long long numops;
  static long long numnot;
  static long long numxor;
  static long long numand;
  static long long numor;
  int b;
public:
  static long long ops(void) { return numops; }
  static long long ops(long long t) {
    if (t == 1) return numnot;
    if (t == 2) return numxor;
    if (t == 3) return numand;
    if (t == 4) return numor;
    if (t == 5) return numand + numor;
    return numops;
  }
  static const char *opsname(long long t) {
    if (t == 1) return "not";
    if (t == 2) return "xor";
    if (t == 3) return "and";
    if (t == 4) return "or";
    if (t == 5) return "quad";
    return "ops";
  }

  int value(void) const { return b; }
  bit(int i = 0) : b(i & 1) { }

  bit operator~() const { ++numops; ++numnot; return bit(b ^ 1); }
  bit operator^(const bit &c) const { ++numops; ++numxor; return bit(b ^ c.b); }
  bit operator&(const bit &c) const { ++numops; ++numand; return bit(b & c.b); }
  bit operator|(const bit &c) const { ++numops; ++numor; return bit(b | c.b); }

  bit operator^=(const bit &c) { *this = *this ^ c; return *this; }
  bit operator&=(const bit &c) { *this = *this & c; return *this; }
  bit operator|=(const bit &c) { *this = *this | c; return *this; }
} ;

#endif
