#include <iostream>
using namespace std;
#include <assert.h>
#include "chain.h"

int main()
{
  for (mpz_class n = 0;n < 1024;++n) {
    for (int W = 1;W <= 100;W += 2) {
      std::vector<int> ops = chain(n,W);

      if (n == 0) {
        assert(ops.size() == 1);
        assert(ops[0] == 0);
      } else {
        assert(ops.size() > 0);
        assert(ops[ops.size() - 1] > 0);
      }

      mpz_class x = 0;
      for (long long i = ops.size() - 1;i >= 0;--i) {
        assert(ops[i] >= 0);
        assert(ops[i] <= W);
        if (ops[i] > 2) assert(ops[i] % 2 == 1);
        if (ops[i] == 0) x *= 2;
        else x += ops[i];
      }
      assert(x == n);
    }
  }

  for (mpz_class n = 1;n < 1024;++n) {
    int W = chain_bestW(n);
    int precomp = (W+1)/2;
    if (W == 1) precomp = 0;
    std::vector<int> ops = chain(n,W);
    cout << n << ' ' << ops.size() - 1 + precomp << ' ' << W << ':';
    for (long long i = 1;i <= W;++i)
      if (i == 2 || i % 2 == 1)
        cout << ' ' << i;
    mpz_class x = ops[ops.size() - 1];
    for (long long i = ops.size() - 2;i >= 0;--i) {
      if (ops[i] == 0) x *= 2;
      else x += ops[i];
      cout << ' ' << x;
    }
    cout << '\n';
  }

  return 0;
}
