#ifndef csidh_h
#define csidh_h

#include "curve.h"
#include <tuple>

std::tuple<
  curve, // curve after one iteration
  std::vector<natural> // new exponent vector after one iteration
>
csidh_iteration(
  curve, // curve over F_p where p is 3 mod 8
  std::vector<mpz_class>, // factors with p+1 = 4*prod(factors)
  std::vector<natural>, // absolute-value-of-exponent vector, same length as factors
  std::vector<bit>, // exponent-is-negative vector, same length as factors
  long long, // number of isogenies per iteration: 1 or 2
  mpz_class // iteration counter: 1, 2, 3, ...
);

curve // curve after many iterations
csidh(
  curve, // as in csidh_iteration
  std::vector<mpz_class>, // as in csidh_iteration
  std::vector<natural>, // as in csidh_iteration
  std::vector<bit>, // as in csidh_iteration
  long long, // as in csidh_iteration
  long long // number of iterations to (hopefully!) clear exponent vector
);

#endif
