#include <iostream>
using namespace std;
#include "csidh.h"

int main()
{
  std::vector<mpz_class> factors;

  factors.push_back(3);
  factors.push_back(5);
  factors.push_back(7);
  factors.push_back(11);
  factors.push_back(13);
  factors.push_back(17);

  mpz_class p = 4;
  for (long long i = 0;i < factors.size();++i)
    p *= factors[i];
  p -= 1;

  assert(mpz_probab_prime_p(p.get_mpz_t(),3));

  curve C(p);
  mpz_class counter = 1;

  for (long long periteration = 1;periteration <= 2;++periteration) {
    long long reduced0 = 0;
    long long reduced1 = 0;
    long long reduced2 = 0;

    for (long long loop = 0;loop < 100;++loop) {
      std::vector<natural> e;
      std::vector<bit> etwist;

      for (long long i = 0;i < factors.size();++i) {
        e.push_back(natural(random() & 3));
        etwist.push_back(bit(random() & 1));
      }
  
      auto result = csidh_iteration(C,factors,e,etwist,periteration,counter);
      counter += 1;

      C = std::get<0>(result);
      auto newe = std::get<1>(result);

      long long numreduced = 0;
      for (long long i = 0;i < factors.size();++i) {
        assert(newe[i].value() <= e[i].value());
        assert(newe[i].value() >= e[i].value() - 1);
        if (newe[i].value() != e[i].value()) ++numreduced;
      }
      if (numreduced == 0) ++reduced0;
      if (numreduced == 1) ++reduced1;
      if (numreduced == 2) ++reduced2;
      assert(numreduced <= periteration);

      cout << "curve " << C.montgomeryA().value() << '\n';
    }

    cout << periteration << ' ' << reduced0 << ' ' << reduced1 << ' ' << reduced2 << '\n';

    if (periteration == 1) assert(reduced1 >= 60);
    if (periteration == 2) assert(reduced2 >= 30);
  }

  return 0;
}
