l = [3,5,7,11,13,17]
n = len(l)
p = 4*prod(l)-1
assert p.is_prime()
k = GF(p)
C = EllipticCurve(k,[1,0])

def mont(E):
  f = E.two_division_polynomial()
  f = f/f.leading_coefficient()
  r = f.roots()
  assert len(r) == 1
  r = r[0][0]
  f = f(f.variables()[0] + r)
  s = sqrt(f[1])
  if not s.is_square(): s = -s
  return f[2]/s

def elligator(E,u):
  A = mont(E)
  if A == 0:
    x = k(0)
    while True:
      x += 1
      if not E.is_x_coord(x): continue
      P = E.lift_x(x)
      if any(ZZ((p+1)/l[i]) * P == 0 for i in range(n)): continue
      return x
  v = A/(u^2-1)
  if (v^3+A*v^2+v).is_square():
    return v
  return -v-A

def random():
  return ZZ(sys.stdin.readline())

counter = 1
for periteration in [1,2]:
  reduced = [0,0,0]
  for loop in range(100):
    e = []
    etwist = []
    for i in range(n):
      e += [random() & 3]
      etwist += [random() & 1]

    olde = [ei for ei in e]

    if periteration == 1:
      for i in reversed(range(n)):
        if e[i]:
          if etwist[i]: C = C.quadratic_twist()
          C = EllipticCurve(k,[0,mont(C),0,1,0])
          P = C.lift_x(elligator(C,counter+1))
          Q = ZZ((p+1)/l[i]) * P
          assert l[i]*Q == 0
          if Q != 0:
            C = C.isogeny(Q).codomain()
            e[i] -= 1
          if etwist[i]: C = C.quadratic_twist()
          break
    else:
      for i1 in reversed(range(n)):
        if e[i1]:
          twisted = etwist[i1]
          l1 = l[i1]

          ok = 0
          for i2 in reversed(range(i1)):
            if e[i2] and etwist[i2] == etwist[i1]:
              ok = 1
              l2 = l[i2]
              break
          if not ok:
            l2 = 1
            i2 = -1

          A = mont(C)
          if twisted: A = -A
          C = EllipticCurve(k,[0,A,0,1,0])

          P = C.lift_x(elligator(C,counter+1))
          R = ZZ(4*prod(l[k] for k in range(n) if k != i1 and k != i2)) * P

          Q = l1 * R
          if i2 >= 0: assert l2*Q == 0
          if Q == 0: i2 = -1
          if i2 >= 0: phi = C.isogeny(Q)
          if i2 >= 0: R = phi(R)
          if i2 >= 0: C = phi.codomain()
          if i2 >= 0: e[i2] -= 1

          Q = R
          if i1 >= 0: assert l1*Q == 0
          if Q == 0: i1 = -1
          if i1 >= 0: phi = C.isogeny(Q)
          if i1 >= 0: C = phi.codomain()
          if i1 >= 0: e[i1] -= 1

          A = mont(C)
          if twisted: A = -A
          C = EllipticCurve(k,[0,A,0,1,0])

          break
      pass

    counter += 1

    numreduced = 0
    for i in range(n):
      assert e[i] <= olde[i]
      assert e[i] >= olde[i] - 1
      if e[i] != olde[i]: numreduced += 1

    assert numreduced <= periteration
    reduced[numreduced] += 1

    print 'curve',mont(C)

  print periteration,reduced[0],reduced[1],reduced[2]
  if periteration == 1: assert reduced[1] >= 60
  if periteration == 2: assert reduced[2] >= 30
