#include <iostream>
using namespace std;
#include "natural.h"

#define TIMINGS 7

int main()
{
  gmp_randstate_t gmprand;
  gmp_randinit_default(gmprand);

  long long t[TIMINGS+1][bit_opsnum];

  for (long long bits = 1;bits <= 512;bits += 1) {
    natural x(0,bits);
    natural y(0,bits);
    mpz_class c;

#define BENCHMARK(NAME,DO) \
    for (long long i = 0;i < TIMINGS;++i) { \
      for (long long cost = 0;cost < bit_opsnum;++cost) t[i][cost] = bit::ops(cost); \
      DO \
    } \
    for (long long cost = 0;cost < bit_opsnum;++cost) { \
      t[TIMINGS][cost] = bit::ops(cost); \
      cout << bits << ' ' << NAME << ' ' << bit::opsname(cost); \
      for (long long i = 0;i < TIMINGS;++i) \
        cout << ' ' << t[i + 1][cost] - t[i][cost]; \
      cout << '\n'; \
    }

    BENCHMARK("add",{natural z = x + y;})
    BENCHMARK("sub",{natural z = x.subtract(y,bits);})
    BENCHMARK("sq",{natural z = x.square();})
    BENCHMARK("mul",{natural z = x * y;})
    BENCHMARK("mulconst",{mpz_urandomb(c.get_mpz_t(),gmprand,bits); natural z = x * c;})

    natural z = x * y;
    BENCHMARK("modconst",{mpz_urandomb(c.get_mpz_t(),gmprand,bits); mpz_setbit(c.get_mpz_t(),bits-1); natural zc = z % c;})

  }
 
  return 0;
}
