#include <iostream>
using namespace std;
#include "point.h"

int main()
{
  mpz_class p("419");
  natural A(124);
  curve C(p,A);
  natural x(411); // point of order 5
  point_affine P(C,x);

  cout << "prime " << p << '\n';
  cout << "curve " << A.value() << '\n';
  cout << "point " << P.xcoordinate().value() << '\n';

  std::vector<natural> inpoints;
  inpoints.push_back(natural(2));
  inpoints.push_back(natural(7));
  inpoints.push_back(natural(11));
  inpoints.push_back(natural(13));
  inpoints.push_back(natural(17));
  inpoints.push_back(natural(19));
  inpoints.push_back(natural(24));
  inpoints.push_back(natural(26));

  auto result = P.isogeny(natural(5),5,inpoints);

  bit correctorder = std::get<0>(result);
  std::vector<natural> points = std::get<1>(result);

  assert(points.size() >= 2);
  assert(points.size() % 2 == 0);

  natural A1 = points[0];
  natural A0 = points[1];
  natural Anew = (A1 * A0.invertmodprime(p)) % p;
  cout << "Anew " << Anew.value() << '\n';

  for (int i = 2;i < points.size();i += 2) {
    natural X = points[i];
    natural Z = points[i+1];
    cout << ((X * Z.invertmodprime(p)) % p).value();
    cout << '\n';
  }

  cout << correctorder.value() << '\n';

  return 0;
}
