#include <stdio.h>
#include <stdlib.h>
#include "knownrandom.h"

#define cutoff 1000
#define C 5
#define n 74

int l[n] = {
  3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53,
  59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113,
  127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181,
  191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251,
  257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317,
  331, 337, 347, 349, 353, 359, 367, 373, 587
} ;

int randomexponent(void)
{
  return knownrandom_range(2*C+1)-C;
}

long long x[cutoff];

int main()
{
  int i;
  int e[n];
  int elen;
  long long loops,iterations,successes;

  for (loops = 0;loops < 10000000;++loops) {
    for (i = 0;i < n;++i)
      e[i] = abs(randomexponent());
    elen = n;

    iterations = 0;
    while (iterations < cutoff) {
      if (elen == 0) {
        ++x[iterations];
        break;
      }
      if (e[elen-1] == 0) {
        --elen;
        continue;
      }
      ++iterations;
      if (knownrandom_range(l[elen-1]))
        --e[elen-1];
    }
  }

  successes = 0;
  for (iterations = 0;iterations < cutoff;++iterations) {
    double failure;
    long long e;

    successes += x[iterations];
    failure = 1 - successes / (1.0 * loops);
    e = 0;
    while (failure > 0 && failure < 0.5) {
      failure *= 2;
      e += 1;
    }
    printf("%lld %.3lf * 2^{-%lld} (%lld)\n",iterations,failure,e,x[iterations]);
  }

  return 0;
}
